import json
import os
from multiprocessing.pool import ThreadPool

class ZipCache:
    def __init__(self):
        self.folder_path = './zip'
        self.check_cache_exist(self)
    
    def write_file(self, data):
        zipcode, jdata = data
        with open(f"{self.folder_path}/{zipcode}", "w") as output_file:
            output_file.write(json.dumps(jdata))

    def check_cache_exist(self):
        current_dir = os.getcwd()
        if not os.path.exists(os.path.join(current_dir, self.folder_path)):
            print("No exisitng zip cache !!!")
            os.makedirs(os.path.join(current_dir, self.folder_path))
        
        file_count = len([name for name in os.listdir(self.folder_path) if os.path.isfile(os.path.join(self.folder_path, name))]) 
        if file_count != 41481:
            with open(os.path.join(current_dir,"./zip_combined.json"), "r") as input_file:
                for line in input_file:
                    jdata = json.loads(line)
                    with ThreadPool() as pool:
                        pool.map(self.write_file, jdata.items())
            print("Cache created successfully !!")
        else:
            print("Cache already exisitng !!")
    
    def getData(self, filename):
        with open(f"{self.folder_path}/{filename}", "r") as input_file: return input_file.read()

